#include <stdio.h>
#include <algorithm>

using namespace std;
int t, n, m, i, j, k[6];
long long int a[75005], b[75005], nzd;
int fun(int a, int b)
{
    if(b==0)
        return a;
    return fun(b, a%b);
}
int main()
{
    scanf("%d", &t);
    for(i=0;i<t;i++)
    {
        scanf("%d%d", &n, &m);
        for(j=0;j<n;j++)
            scanf("%lld", &a[j]);
        for(j=0;j<m;j++)
            scanf("%lld", &b[j]);
        nzd=abs(a[0]-a[1]);
        for(j=2;j<n;j++)
            nzd=fun(nzd, abs(a[j]-a[j-1]));
        for(j=0;j<m;j++)
            if(b[j]%nzd==a[0]%nzd)
                k[i]=1;
    }
    for(i=0;i<t;i++)
    {
        if(k[i]==0)
            printf("1\n");
        else
            printf("0\n");
    }
    return 0;
}